typedef DWORD SMHANDLE;
typedef LOCALHANDLE FAR *LPLOCALHANDLE;
typedef LPVOID FAR *LPLPVOID;
typedef SMHANDLE FAR *LPSMHANDLE;

#define SMEM_NOSWAP 1
#define SMEM_SWAPFILE 2
#define SMEM_SWAPEMS 4

typedef enum
{
	SMEE_OK,

	SMEE_EMSSOFTWAREERROR=0x80,
	SMEE_EMSHARDWAREERROR=0x81,
	SMEE_EMSBUSY=0x82,
	SMEE_EMSHANDLEINVALID=0x83,
	SMEE_EMSUNDEFINEDFUNCTION=0x84,
	SMEE_EMSNOMOREHANDLES=0x85,
	SMEE_EMSBADMAPPINGCONTEXT=0x86,
	SMEE_EMSTOOFEWPAGESTOTAL=0x87,
	SMEE_EMSTOOFEWPAGESFREE=0x88,
	SMEE_EMSCANTALLOC0PAGES=0x89,
	SMEE_EMSBADLOGICALPAGE=0x8A,
	SMEE_EMSBADPHYSICALPAGE=0x8B,
	SMEE_EMSPAGEMAPHARDWAREFULL=0x8C,
	SMEE_EMSCONTEXTSAVEFAILED=0x8D,
	SMEE_EMSCONTEXTRESTOREFAILED=0x8E,
	SMEE_EMSUNDEFINEDSUBFUNCTION=0x8F,
	SMEE_EMSUNDEFINEDATTRIBTYPE=0x90,
	SMEE_EMSFEATURENOTSUPPORTED=0x91,

	SMEE_FILESEEKERROR=0x100,
	SMEE_FILEWRITEERROR,
	SMEE_FILEREADERROR,
	SMEE_FILEOPENERROR,

	SMEE_INVALIDPARAMETER=0x200,
	SMEE_NOMEMORY,
	SMEE_FREEEXHAUSTED,
	SMEE_SIZETOOLARGE,
	SMEE_TOOMANYBLOCKS,
	SMEE_CANTCREATESWAPFILE
} SMERRORENUM;

SMERRORENUM FAR PASCAL SMTypeAlloc(WORD wDataSize,WORD wfsMin,WORD wFlags,
	LPLOCALHANDLE lplhts);
SMERRORENUM FAR PASCAL SMTypeFree(LOCALHANDLE lhts);
SMERRORENUM FAR PASCAL SMLock(LOCALHANDLE lhts,SMHANDLE smh,LPLPVOID lplp);
SMERRORENUM FAR PASCAL SMUnlock(LOCALHANDLE ghts,SMHANDLE smh);
SMERRORENUM FAR PASCAL SMAlloc(LOCALHANDLE ghts,WORD wSize,
	LPSMHANDLE lpsmh);
SMERRORENUM FAR PASCAL SMFree(LOCALHANDLE ghts,SMHANDLE smh,WORD wSize);
VOID FAR PASCAL SMInit(void);
