; File routines for SMALLOC.

.MODEL						SMALL

extrn						DOS3CALL:far

TRUE						equ 1
FALSE						equ 0

.CODE

public						_FileOpen

_FileOpen					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileOpen(LPSTR lpszFileName,BYTE cAttrib,LPINT lpnfh);

							push bp
							mov bp,sp

							mov ah,03Dh
							mov al,[bp+8]
							push ds
							lds dx,[bp+4]
							call DOS3CALL
							pop ds
							jc FO_1
							les bx,[bp+10]
							mov es:[bx],ax
							mov ax,0

	FO_1:					pop bp
							ret

_FileOpen					endp

public						_FileClose

_FileClose					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileClose(int nfh);

							push bp
							mov bp,sp

							mov ah,03Eh
							mov bx,[bp+4]
							call DOS3CALL
							jc FC_1
							mov ax,0

	FC_1:					pop bp
							ret

_FileClose					endp

public						_FileRead

_FileRead					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileRead(int nfh,LPSTR lps,WORD wNumToRead,
	;	LPWORD lpwNumRead);

							push bp
							mov bp,sp

							mov ah,03Fh
							mov bx,[bp+4]
							push ds
							lds dx,[bp+6]
							mov cx,[bp+10]
							call DOS3CALL
							pop ds
							jc FR_1
							les bx,[bp+12]
							mov es:[bx],ax
							mov ax,0

	FR_1:					pop bp
							ret

_FileRead					endp

public						_FileWrite

_FileWrite					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileWrite(int nfh,LPSTR lps,WORD wNumToWrite,
	;	LPWORD lpwNumWritten);

							push bp
							mov bp,sp

							mov ah,040h
							mov bx,[bp+4]
							push ds
							lds dx,[bp+6]
							mov cx,[bp+10]
							call DOS3CALL
							pop ds
							jc FW_1
							les bx,[bp+12]
							mov es:[bx],ax
							mov ax,0

	FW_1:					pop bp
							ret

_FileWrite					endp

public						_FileDelete

_FileDelete					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileDelete(LPSTR lpszFileName);

							push bp
							mov bp,sp

							mov ah,041h
							push ds
							lds dx,[bp+4]
							call DOS3CALL
							pop ds
							jc FD_1
							mov ax,0

	FD_1:					pop bp
							ret

_FileDelete					endp

public						_FileSeek

_FileSeek					proc near

	; Returns SMEE_OK if ok, otherwise an error.
	; SMERRORENUM FileSeek(int nfh,DWORD dwPos,BYTE cMethod,LPDWORD lpdwPos);

							push bp
							mov bp,sp

							mov ah,042h
							mov bx,[bp+4]
							mov dx,[bp+6]
							mov cx,[bp+8]
							mov al,[bp+10]
							call DOS3CALL
							jc FS_1
							les bx,[bp+12]
							mov es:[bx],ax
							mov es:[bx+2],dx
							mov ax,0

	FS_1:					pop bp
							ret

_FileSeek					endp

end
